
#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include "atom.h"
#include "gobj.h"
#include "file_list_maker_items.h"

// O[oE_CAOpvV[W
BOOL CALLBACK StaticDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);

// J[\
set_cursor(HWND hwnd, char *cur_name);

// tH_̑I_CAO
call_folderdialog(HWND hwnd, HWND hedit);

// t@CJ
open_file(HWND hwnd, char *filename);

// t@C폜
remove_file(HWND hwnd, char *filename);

// t@C̃vpeBĂяo
HANDLE call_property_seet(HWND hwnd, char *filename);

// t@CύX
change_filename(HWND hwnd, char *dir, char *filename1, char *filename2);

// =========Xg\EBhENX================
class CHILD_LIST_WIN {
	public:
	HWND m_hwnd;
	GFONT m_gfont;
	G_SCROLL_BAR m_vscroll, m_hscroll;
	LIST_PACK m_list_pack;
	int m_winx, m_winy;
	int m_count_at_once;	// m_list_up_count_at_once
	HWND m_hdlg_nowlistting;
	int m_accumulation_count, m_folder_accumulation_count, m_file_accumulation_count;
	ESTAB_DATA *m_p_estab;
	HEADER_CC m_header_cc;
	int m_change_filename_type;
	GT_DIB m_back_dib;

	// ` Zp ꎞϐ
	int m_dc_work_co_x[IDE_ITEM_ORDER_MAX];
	int m_dc_work_co_width[IDE_ITEM_ORDER_MAX];
	int m_dc_work_font_height;
	int m_output_work_filetype;
	HDC m_dc_work_hdc_plus_bmp, m_dc_work_hdc_minus_bmp;
	HDC m_dc_work_hdc_sel_plus_bmp, m_dc_work_hdc_sel_minus_bmp;
	HBITMAP m_hbmp_sel_plus, m_hbmp_sel_minus;
	HBITMAP m_hbmp_plus, m_hbmp_minus;

	// ^C}[p
	PLIST<FIND_PATH_ITEM> m_find_path_stack;
	FOLDER_INFO_DATA *m_now_find_folder;
	char *m_now_find_path;
	set_now_find_path(char *path);
	inline void findnext_inline(FIND_PATH_ITEM *p_fpi, char *path);
	FOLDER_INFO_DATA *m_sel_folder;
	int m_sel_num, m_sel_type;
	start_timer_list_up();
	void next_timer_list_up();
	end_timer_list_up();
	list_up_complete_dialog();

	// ֐
//	static BOOL CALLBACK StaticDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	static LRESULT CALLBACK StaticChildListWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	LRESULT CALLBACK ChildListWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	static BOOL CALLBACK StaticNowListtingDlgProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp);
	BOOL CALLBACK NowListtingDlgProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp);

	static BOOL CALLBACK StaticChangeNameProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	BOOL CALLBACK ChangeNameProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);


	clear_list();
	set_list_pack(char *path);
	draw_list_inline(GT_DIB *p_dib, int name_x, int &y, FOLDER_INFO_DATA* p_folder, int &start_num);
	void on_paint();
	void renew_size();
	void renew_size_horz();


	CHILD_LIST_WIN();
	~CHILD_LIST_WIN(){
		if (m_now_find_path) delete[] m_now_find_path;
	}

	// o
	void output_html_head(FILE *fp);
	void output_html_tail(FILE *fp);
	void output_indent(FILE *fp, int indent);
	void output_new_line(FILE *fp);
	void output_eachitem_head(FILE *fp, int colspan);
	void output_eachitem_tail(FILE *fp);
	output_list_inline(FILE *fp, FOLDER_INFO_DATA *p_folder, int depth);
	output_list();

	// \[g
	sort(int id);
	insert_sort(int id);
	insert_sort_inline(int id, FOLDER_INFO_DATA *p_folder);
	compare_file(int id, FILE_INFO_DATA *p_file_1, FILE_INFO_DATA *p_file_2);
	compare_folder(int id, FOLDER_INFO_DATA *p_folder_1, FOLDER_INFO_DATA *p_folder_2);

	call_change_filename(HWND hedit);
	// 
	on_create();
	get_num_by_pos();
	on_lbuttondown();
	on_rbuttondown();
	on_command(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);

	get_num_by_pos(POINT po, FOLDER_INFO_DATA **res_pp_folder, int &type, int &num);
	get_num_by_pos_inline(
		FOLDER_INFO_DATA **res_pp_folder, FOLDER_INFO_DATA *p_folder, int &target, int &type, int &num);
};

// =========o͍ڃEBhE==================
class ESTAB_WIN {
	public :
	int m_tmp_order[IDE_ITEM_ORDER_MAX], m_tmp_order_len;
	HWND m_item_order_win;
	GFONT m_gfont, m_gfont_mini;
	int m_tmp_sub_dir_indent;

	static LRESULT CALLBACK StaticItemOrderWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	LRESULT CALLBACK ItemOrderWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
	static BOOL CALLBACK StaticEstabDlgProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp);
	BOOL CALLBACK EstabDlgProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp);

	ESTAB_WIN();
};

// ============AvP[VNX==================
class APP{
	public :
	ESTAB_DATA m_estab;
	ESTAB_WIN m_estab_win;
	HWND m_hwnd, m_foldername_edit, m_erase_list_button;
	HWND m_foldername_ref_button, m_establish_button, m_output_button, m_foldername_call_histoy_button;
	CHILD_LIST_WIN m_list_child_win;
	GFONT m_gfont, m_gfont_mini;

	G_CHECK_BOX m_sub_folder_checkbox, m_folder_only_checkbox;

	on_size();
	void on_create(HWND hwnd, WPARAM wp, LPARAM lp);
	void load_ini();
	void save_ini();
	call_foldername_history_menu();
	void add_history(char *s);
	void on_paint();

	call_list_up_wizard();
	call_estab_dialog(HWND hwnd);
	update_item_order();
	static LRESULT CALLBACK StaticWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) ;
	LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) ;
};
