
#include "file_list_maker.h"

// t@C̃vpeBĂяo
HANDLE call_property_seet(HWND hwnd, char *filename){
	SHELLEXECUTEINFO execinfo;
	memset(&execinfo,0,sizeof(SHELLEXECUTEINFO));
	execinfo.cbSize = sizeof(SHELLEXECUTEINFO);
	execinfo.fMask = SEE_MASK_INVOKEIDLIST | SEE_MASK_NOCLOSEPROCESS;
	execinfo.lpVerb = "properties";
	execinfo.lpFile = filename;
	execinfo.hwnd = hwnd;
	execinfo.hInstApp = GetModuleHandle(NULL);

	int res = ShellExecuteEx(&execinfo);

	return (res)? execinfo.hProcess : NULL;
}
// t@CύX
change_filename(HWND hwnd, char *dir, char *filename1, char *filename2){
	char *fn1, *fn2;
	int len_d, len1, len2;
	len_d = strlen(dir);
	len1 = strlen(filename1);
	len2 = strlen(filename2);

	SHFILEOPSTRUCT sfo;   // SHFILEOPSTRUCT\
	memset(&sfo, 0, sizeof(SHFILEOPSTRUCT));
	sfo.hwnd = hwnd;			// EBhEnh
	sfo.wFunc = FO_RENAME;		// s鑀

	fn1 = new char[len_d+len1+2+1];
	fn2 = new char[len_d+len2+2+1];
	strcpy(fn1, dir);	strcat(fn1, "\\");	strcat(fn1, filename1);		fn1[len_d+len1+1] = NULL;
	strcpy(fn2, dir);	strcat(fn2, "\\");	strcat(fn2, filename2);		fn2[len_d+len2+1] = NULL;

	sfo.pFrom = fn1; 			// Ώۃt@C
	sfo.pTo = fn2;				// ړIt@C
	dialog(fn1);
	dialog(fn2);

	SHFileOperation(&sfo);

	delete[] fn1;
	delete[] fn2;
}
			
// t@C폜
remove_file(HWND hwnd, char *filename){
	// double null-terminated ɂ
	int n=strlen(filename);
	filename[n+1]=NULL;

	// SHFILEOPSTRUCT \̃o̒lݒ
	SHFILEOPSTRUCT FileOp;
	FileOp.hwnd = hwnd;
	FileOp.wFunc = FO_DELETE;
	FileOp.pFrom = filename;
	FileOp.pTo = NULL; // pTo is ignored.
	FileOp.fFlags = FOF_ALLOWUNDO | FOF_NOCONFIRMATION | FOF_NOERRORUI | FOF_SILENT;
	FileOp.fAnyOperationsAborted = FALSE;
	FileOp.hNameMappings = NULL;
	FileOp.lpszProgressTitle = NULL;

	// t@C폜
	return SHFileOperation( &FileOp );
}
// t@CJ
open_file(HWND hwnd, char *filename){
	ShellExecute(hwnd, "open", filename, NULL, NULL, SW_SHOWNORMAL );
	return 0;
}

// tH_̑I_CAOiR[obN֐j
int CALLBACK BrowseCallbackProc(HWND hwnd, UINT msg, LPARAM lparam, LPARAM lpdata){
	if(msg==BFFM_INITIALIZED) SendMessage(hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpdata);
	return DefWindowProc(hwnd, msg, lparam, lpdata);
}
// tH_̑I_CAO
call_folderdialog(HWND hwnd, HWND hedit){
	BROWSEINFO binfo;
	ITEMIDLIST *p_id_list;
	TCHAR dir_path[MAX_PATH];
	GetWindowText(hedit, dir_path, MAX_PATH);
	int res;

	// BROWSEINFO\̂ɒlݒ
	binfo.hwndOwner 		= hwnd;			// _CAO̐eEChẼnh
	binfo.pidlRoot			= NULL; 					// [gtH_ITEMIDLIST̃|C^ (NULL̏ꍇfXNgbvtH_g܂j
	binfo.pszDisplayName	= dir_path;					// IꂽtH_󂯎obt@̃|C^
	binfo.lpszTitle 		= TEXT("tH_̑I"); 	// c[r[̏㕔ɕ\镶 
	binfo.ulFlags			= BIF_NEWDIALOGSTYLE; 	// \tH_̎ނtO
	binfo.lpfn				= BrowseCallbackProc; 		// BrowseCallbackProc֐̃|C^
	binfo.lParam			= (LPARAM)dir_path;			// R[obN֐ɓnl

	// tH_I_CAO\
	res = -1;
	p_id_list = ::SHBrowseForFolder(&binfo);
	if(p_id_list != NULL){	// tH_Is
		if(::SHGetPathFromIDList(p_id_list, dir_path)) {
			SetWindowText(hedit, dir_path);
			res = (dir_path && strlen(dir_path)>0)? 0 : -1;
		}
		::CoTaskMemFree( p_id_list );	// p_id_list̃J
	}

	return res;
}
// J[\
set_cursor(HWND hwnd, char *cur_name){
	HCURSOR hc=LoadCursor(NULL, cur_name);
	if (hc) {
		HCURSOR old_cur=(HCURSOR)SetClassLong(hwnd, GCL_HCURSOR, (long)hc);
		return DestroyCursor(old_cur);
	}
	return 0;
}

// 
BOOL CALLBACK StaticDlgProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	switch (msg) {
	case WM_CLOSE:
		EndDialog(hwnd, IDCANCEL);
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDOK:	EndDialog(hwnd, IDOK);	break;
		case IDCANCEL:	EndDialog(hwnd, IDCANCEL);	break;
		}
		return TRUE;
	}
	return FALSE;
}