
#include "file_list_maker.h"

// =========o͍ڃEBhE==================
// ڏEBhE RXg^N^
ESTAB_WIN::ESTAB_WIN(){
	m_item_order_win =NULL;
	m_tmp_order_len = 0;
};
// ڏEBhEER[obNstatic
LRESULT CALLBACK ESTAB_WIN::StaticItemOrderWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	ESTAB_WIN *pwin = (ESTAB_WIN*)GetWindowLong(hwnd, GWL_USERDATA);
	if (!pwin && (msg==WM_NCCREATE || msg==WM_CREATE)){
		pwin = (ESTAB_WIN*)((LPCREATESTRUCT)lp)->lpCreateParams;
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)pwin);
	}
	if (pwin) return pwin->ItemOrderWndProc(hwnd, msg, wp, lp);
	return DefWindowProc(hwnd, msg, wp, lp);
}

// ڏEBhEER[obN
LRESULT CALLBACK ESTAB_WIN::ItemOrderWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) {
	HDC hdc;
	TEXTMETRIC tm;
	PAINTSTRUCT pt;
	int i, y, res;
	char *ps, s[50];
	switch (msg) {
	case WM_DESTROY:
		break;
	case WM_VSCROLL:
	//	m_vscroll.on_scroll(wp, lp);
		InvalidateRect(hwnd, NULL, TRUE);
		break;
	case WM_CREATE:
		m_item_order_win = hwnd;
		break;
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &pt);
		SelectObject(hdc, m_gfont.m_hfont);
		GetTextMetrics(hdc, &tm);
		y=3;
		for(i=0;i<m_tmp_order_len;i++){
			switch(m_tmp_order[i]){
			case IDE_FILENAME		:	ps="t@C";	break;
			case IDE_FILESIZE		:	ps="t@CTCY";	break;
			case IDE_FILEATT		:	ps="";	break;
			case IDE_FILEACCESSTIME :	ps="ŏIANZX";	break;
			case IDE_FILEWRITETIME	:	ps="XV";	break;
			case IDE_FILECREATETIME	:	ps="쐬";	break;
			};
			sprintf(s, "%d : %s", i+1, ps);
			TextOut(hdc, 3, y, s, strlen(s));
			y += tm.tmHeight;
		}
		EndPaint(hwnd, &pt);
		break;
	}
	return DefWindowProc(hwnd, msg, wp, lp);
}
// StaticEstabDlgProc
BOOL CALLBACK ESTAB_WIN::StaticEstabDlgProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp) {
	ESTAB_WIN *pwin = (ESTAB_WIN*)GetWindowLong(hwnd, GWL_USERDATA);
	if (!pwin && (msg==WM_INITDIALOG)){
		pwin = (ESTAB_WIN*)lp;
		SetWindowLong(hwnd, GWL_USERDATA, (LONG)pwin);
	}
	if (pwin) return pwin->EstabDlgProc(hwnd, msg, wp, lp);
	return FALSE;
}
// EstabDlgProc
BOOL CALLBACK ESTAB_WIN::EstabDlgProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp) {
	int i, res;
	switch (msg) {
	case WM_CLOSE:
		EndDialog(hwnd, IDCANCEL);
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDOK:
			EndDialog(hwnd, IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hwnd, IDCANCEL);
			return TRUE;
		case IDE_FILENAME		: 
		case IDE_FILESIZE		: 
		case IDE_FILEATT		: 
		case IDE_FILEACCESSTIME : 
		case IDE_FILEWRITETIME	: 
		case IDE_FILECREATETIME :
			if (BST_CHECKED == SendMessage(GetDlgItem(hwnd, LOWORD(wp)), BM_GETCHECK, 0, 0)) {
				res = -1;
				for(i=0;i<m_tmp_order_len;i++){
					if (m_tmp_order[i]==LOWORD(wp)) { res=i; break; }
				}
				if (res==-1) {
					m_tmp_order[i]=LOWORD(wp);
					m_tmp_order_len++;
				}
			}
			else {
				res = -1;
				for(i=0;i<m_tmp_order_len;i++){
					if (m_tmp_order[i]==LOWORD(wp)) { res=i; break; }
				}
				if (res>=0) {
					m_tmp_order_len--;
					for(i=res;i<m_tmp_order_len;i++) m_tmp_order[i]=m_tmp_order[i+1];
				}
			}
			InvalidateRect(m_item_order_win, NULL, TRUE);
			return TRUE;
		}
	case IDC_SUB_DIR_INDENT:
		if (BST_CHECKED == SendMessage(GetDlgItem(hwnd, LOWORD(wp)), BM_GETCHECK, 0, 0)) {
			m_tmp_sub_dir_indent = 1;
		}
		else {
			m_tmp_sub_dir_indent = 0;
		}
		return TRUE;
	case WM_INITDIALOG:
		m_gfont.set_size(14);
		m_gfont_mini.set_size(11);
		CreateWindow(
			TEXT("FILE_LIST_ITEM_ORDER_WIN"), TEXT(""), WS_CHILD | WS_VISIBLE | WS_BORDER,
			170, 85, 130, 100, hwnd, (HMENU)0, GetModuleHandle(NULL), (LPVOID)this
		);
		SendMessage(GetDlgItem(hwnd, IDE_FILENAME), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);
		SendMessage(GetDlgItem(hwnd, IDE_FILESIZE), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);
		SendMessage(GetDlgItem(hwnd, IDE_FILEATT), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);
		SendMessage(GetDlgItem(hwnd, IDE_FILECREATETIME), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);
		SendMessage(GetDlgItem(hwnd, IDE_FILEACCESSTIME), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);
		SendMessage(GetDlgItem(hwnd, IDE_FILEWRITETIME), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);

		SendMessage(GetDlgItem(hwnd, 1), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);
		SendMessage(GetDlgItem(hwnd, 2), WM_SETFONT, (WPARAM)m_gfont.m_hfont, TRUE);

		SendMessage(GetDlgItem(hwnd, IDC_SUB_DIR_INDENT), WM_SETFONT, (WPARAM)m_gfont_mini.m_hfont, TRUE);
	//	SendMessage(GetDlgItem(hwnd, IDC_FILESIZE_UNIT), WM_SETFONT, (WPARAM)m_gfont_mini.m_hfont, TRUE);
		for(i=0;i<m_tmp_order_len;i++){
			switch(m_tmp_order[i]){
			case IDE_FILENAME		: 
			case IDE_FILESIZE		: 
			case IDE_FILEATT		: 
			case IDE_FILEACCESSTIME : 
			case IDE_FILEWRITETIME	: 
			case IDE_FILECREATETIME	: 
				SendMessage(GetDlgItem(hwnd, m_tmp_order[i]), BM_SETCHECK, BST_CHECKED, 0);	break;
			};
		}
		if (m_tmp_sub_dir_indent) 
				SendMessage(GetDlgItem(hwnd, IDC_SUB_DIR_INDENT), BM_SETCHECK, BST_CHECKED, 0);
		return TRUE;
	}
	return FALSE;
}
