
#ifndef _QLIST_H_
#define _QLIST_H_

#include <stdio>
#include <stdlib>
#include "plist.h"

//==========================================
//		QLIST	NCbNEXg			
//==========================================
template <class T> class QLIST {
	public :
	int pret_size;
	PLIST<T> plist;	// has a^ipush쐬̂is ałȂj

	swap(int n1, int n2){
		plist.swap(n1, n2);
	};
	T* &last(){	return plist.last(); };
	size()		{ return pret_size; };		// ACeԂ
	mem_size()	{ return plist.size(); };	// EACeԂ
	resize(int n=-1){
		if (n<0) n= pret_size;
		if (n>plist.size()) plist.resize(n);	// ǉ
		return pret_size=n;
	};
	mem_resize(int n){ return plist.resize(n); };
	T *a_push(int n=-1){	// I[gEvbV
		if (n<0 || n>pret_size) n=pret_size;
		if (pret_size>=plist.size()) plist.a_push(n);
		else if (n>=0 && n<pret_size) {
			plist.roll(pret_size, n);
		//	*(plist[n])=t;	// ʏvbV
		}
		pret_size++;
		return plist[n];
	}
	pop(int n=-1){
		if (pret_size<=0) return 0;
		if (n>0) plist.roll(n, pret_size);
		pret_size--;
	}
	mem_pop(int n=-1){	return plist.pop(n);	}
	// _ANZX
	T* &operator [](int n){
		if (pret_size<=n) return plist[-1];
		return plist[n];
	};

	// RXgN^
	QLIST(){
		pret_size=0;
	};
	del_all(){
		pret_size=0;
	}
	mem_del_all(){
		pret_size=0;
		plist.del_all();
	}
};
//==========================================
//		Q_XLIST	NCbNEXg			
//==========================================
template <class T> class Q_XLIST {
	public :
	int pret_size;
	XLIST<T> xlist;	// has a^ipush쐬̂is ałȂj

	swap(int n1, int n2){
		xlist.swap(n1, n2);
	};
	T &last(){	return xlist.last(); };
	size()		{ return pret_size; };		// ACeԂ
	mem_size()	{ return xlist.size(); };	// EACeԂ
	resize(int n=-1){
		if (n<0) n= pret_size;
		if (n>xlist.size()) xlist.resize(n);	// ǉ
		return pret_size=n;
	};
	mem_resize(int n=-1){
		if (n<0) n= pret_size;
		pret_size=n;
		return xlist.resize(n);
	};
	push(T t){
		pret_size++;
		return xlist.push(t);
	}
	push(T t, int n){		// ACeǉ{
		pret_size++;
		return xlist.push(t, n);
	}
	pop(int n=-1){
		if (pret_size<=0) return 0;
		if (n>0) xlist.roll(n, pret_size);
		pret_size--;
	}
	mem_pop(int n=-1){	return xlist.pop(n);	}
	// _ANZX
	T &operator [](int n){
		if (pret_size<=n) return xlist[-1];
		return xlist[n];
	};

	// RXgN^
	Q_XLIST(){
		pret_size=0;
	};
	del_all(){
		pret_size=0;
	}
	mem_del_all(){
		pret_size=0;
		xlist.del_all();
	}
};

#endif  // _QLIST_H_

